Index: compare
===================================================================
--- compare	(revision 5852c866b0b68e7ed626252d76561ef3fe4baace)
+++ compare	(revision 5852c866b0b68e7ed626252d76561ef3fe4baace)
@@ -0,0 +1,20 @@
+#!/usr/bin/env python
+
+import sys
+import os
+import glob
+
+def main():
+    sasmodels = os.path.dirname(os.path.abspath(__file__))
+    root = os.path.dirname(sasmodels)
+    sasview=glob.glob(os.path.join(root, 'sasview', 'build', 'lib.*' ))[0]
+    sys.path.insert(0, os.path.join(root, 'bumps'))
+    sys.path.insert(0, os.path.join(root, 'periodictable'))
+    sys.path.insert(0, sasview)
+    sys.path.insert(0, sasmodels)
+
+    import sasmodels.compare
+    sasmodels.compare.main()
+
+if __name__ == "__main__":
+    main()
Index: doc/genmodel.py
===================================================================
--- doc/genmodel.py	(revision c094758ad0df0ba9f8a4aa5b788a7c4f1bdf249f)
+++ doc/genmodel.py	(revision 044a9c12e31225b960e033a80e969530db1641d4)
@@ -2,4 +2,5 @@
 import numpy as np
 import matplotlib.pyplot as plt
+import pylab
 sys.path.insert(0, os.path.abspath('..'))
 from sasmodels import generate, core
@@ -28,5 +29,5 @@
     'q_max'     : 1.0,
     'nq'        : 1000,
-    'nq2d'      : 400,
+    'nq2d'      : 100,
     'vmin'      : 1e-3,  # floor for the 2D data results
     'qx_max'    : 0.5,
@@ -59,9 +60,15 @@
     if opts['zscale'] == 'log':
         Iq2D = np.log(np.clip(Iq2D, opts['vmin'], np.inf))
-    h = ax.imshow(Iq2D, interpolation='nearest', aspect=1, origin='upper',
-           extent=[-qx_max, qx_max, -qx_max, qx_max], cmap=ice_cm())
-    # , vmin=vmin, vmax=vmax)
+    ax.imshow(Iq2D, interpolation='nearest', aspect=1, origin='lower',
+        extent=[-qx_max, qx_max, -qx_max, qx_max], cmap=pylab.cm.jet)   
     ax.set_xlabel(r'$Q_x \/(\AA^{-1})$')
     ax.set_ylabel(r'$Q_y \/(\AA^{-1})$')
+
+#            im = self.subplot.imshow(output, interpolation='nearest',
+#                                     origin='lower',
+#                                     vmin=zmin_temp, vmax=self.zmax_2D,
+#                                     cmap=self.cmap,
+#                                     extent=(self.xmin_2D, self.xmax_2D,
+#                                             self.ymin_2D, self.ymax_2D))
 
 def ice_cm():
@@ -77,5 +84,5 @@
 
 
-# Generate image (comment IF for 1D/2D for the moment) and generate only 1D
+# Generate image 
 fig_height = 3.0 # in
 fig_left = 0.6 # in
@@ -97,4 +104,5 @@
     plot_2d(model, opts, ax2d)
     ax1d = fig.add_axes([ax_left, ax_bottom, ax_width, ax_height])
+    plot_1d(model, opts, ax1d)
     #ax.set_aspect('square')
 else:
@@ -109,5 +117,5 @@
     fig = plt.figure(figsize=aspect)
     ax1d = fig.add_axes([ax_left, ax_bottom, ax_width, ax_height])
-plot_1d(model, opts, ax1d)
+    plot_1d(model, opts, ax1d)
 
 # Save image in model/img
@@ -121,5 +129,8 @@
 captionstr += '.. figure:: img/' + model_info['id'] + '_autogenfig.png\n'
 captionstr += '\n'
-captionstr += '    1D plot corresponding to the default parameters of the model.\n'
+if model_info['has_2d']:
+    captionstr += '    1D and 2D plots corresponding to the default parameters of the model.\n'
+else:
+    captionstr += '    1D plot corresponding to the default parameters of the model.\n'
 captionstr += '\n'
 
Index: example/sesansfit.py
===================================================================
--- example/sesansfit.py	(revision 84db7a50ae40a38a16b4f9c6430e31c26f8407f4)
+++ example/sesansfit.py	(revision 170ea69cd9ce6a059d8adf8d340e81b5064042b9)
@@ -1,4 +1,5 @@
 from bumps.names import *
 from sasmodels import core, bumps_model, sesans
+from sas.sascalc.dataloader.loader import Loader
 
 HAS_CONVERTER = True
@@ -8,4 +9,5 @@
     HAS_CONVERTER = False
 
+
 def get_bumps_model(model_name):
     kernel = core.load_model(model_name)
@@ -13,6 +15,7 @@
     return model
 
-def sesans_fit(file, model, initial_vals={}, custom_params={}, param_range=[]):
+def sesans_fit(file, model, initial_vals={}, custom_params={}, param_range=[], acceptance_angle=None):
     """
+
     @param file: SESANS file location
     @param model: Bumps model object or model name - can be model, model_1 * model_2, and/or model_1 + model_2
@@ -24,5 +27,4 @@
     """
     try:
-        from sas.sascalc.dataloader.loader import Loader
         loader = Loader()
         data = loader.load(file)
@@ -55,6 +57,9 @@
             dy = err_data
             sample = Sample()
+            needs_all_q = acceptance_angle is not None
         data = SESANSData1D()
+        data.acceptance_angle = acceptance_angle
 
+    data.needs_all_q = acceptance_angle is not None
     if "radius" in initial_vals:
         radius = initial_vals.get("radius")
Index: example/sesansfit.sh
===================================================================
--- example/sesansfit.sh	(revision bdb653cc842ebbb2483def7e99946c8db6fb3346)
+++ example/sesansfit.sh	(revision 170ea69cd9ce6a059d8adf8d340e81b5064042b9)
@@ -1,6 +1,15 @@
 #!/bin/bash
 
-SASVIEW=$PWD/../../sasview/src
-PYTHONPATH=$PWD/../:$PWD/../../bumps:$PWD/../../periodictable:$SASVIEW
+# Need to fix the paths to sasmodels and sasview if no eggs present
+echo $PWD
+ONEUP="$(dirname "$PWD")"
+PROJECTS="$(dirname "$ONEUP")"
+CCOLON="C:/"
+CSLASH="/c/"
+SASMODELSBASE=$PROJECTS/sasmodels/
+SASMODELS="${SASMODELSBASE/$CSLASH/$CCOLON}"
+SASVIEWBASE=$PROJECTS/sasview/src/
+SASVIEW="${SASVIEWBASE/$CSLASH/$CCOLON}"
+PYTHONPATH="$SASVIEW;$SASMODELS"
 export PYOPENCL_CTX PYTHONPATH
 
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision 78d3341c5d095cf5c713ac48cb7e918807415d33)
+++ sasmodels/convert.py	(revision 74f7238cb6c48971beea1fac687b23814387b471)
@@ -15,5 +15,5 @@
     'be_polyelectrolyte',
     'correlation_length',
-    'fractal_core_shell'
+    'fractal_core_shell',
     'binary_hard_sphere',
 ]
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision 7b3e62cb529ae72b9e299f503716e786281f6f83)
+++ sasmodels/core.py	(revision d5ba8419b0a797faa3fe41fde9334c5a19282992)
@@ -170,11 +170,10 @@
     """
     value, weight = zip(*pars)
-    if len(value) > 1:
-        value = [v.flatten() for v in np.meshgrid(*value)]
-        weight = np.vstack([v.flatten() for v in np.meshgrid(*weight)])
-        weight = np.prod(weight, axis=0)
+    value = [v.flatten() for v in np.meshgrid(*value)]
+    weight = np.vstack([v.flatten() for v in np.meshgrid(*weight)])
+    weight = np.prod(weight, axis=0)
     return value, weight
 
-def call_kernel(kernel, pars, cutoff=0):
+def call_kernel(kernel, pars, cutoff=0, mono=False):
     """
     Call *kernel* returned from :func:`make_kernel` with parameters *pars*.
@@ -189,5 +188,9 @@
     fixed_pars = [pars.get(name, kernel.info['defaults'][name])
                   for name in kernel.fixed_pars]
-    pd_pars = [get_weights(kernel.info, pars, name) for name in kernel.pd_pars]
+    if mono:
+        pd_pars = [( np.array([pars[name]]), np.array([1.0]) )
+                   for name in kernel.pd_pars]
+    else:
+        pd_pars = [get_weights(kernel.info, pars, name) for name in kernel.pd_pars]
     return kernel(fixed_pars, pd_pars, cutoff=cutoff)
 
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision 17bbadde9de73711781f748816b06e6956dc8cfa)
+++ sasmodels/direct_model.py	(revision 02e70ffbd2f37e9a91d5d027972b30069bd05c6b)
@@ -69,4 +69,5 @@
 
         if self.data_type == 'sesans':
+            
             q = sesans.make_q(data.sample.zacceptance, data.Rmax)
             index = slice(None, None)
@@ -77,5 +78,6 @@
                 Iq, dIq = None, None
             #self._theory = np.zeros_like(q)
-            q_vectors = [q]
+            q_vectors = [q]            
+            q_mono = sesans.make_all_q(data)
         elif self.data_type == 'Iqxy':
             if not partype['orientation'] and not partype['magnetic']:
@@ -96,4 +98,5 @@
             #self._theory = np.zeros_like(self.Iq)
             q_vectors = res.q_calc
+            q_mono = []
         elif self.data_type == 'Iq':
             index = (data.x >= data.qmin) & (data.x <= data.qmax)
@@ -120,4 +123,5 @@
             #self._theory = np.zeros_like(self.Iq)
             q_vectors = [res.q_calc]
+            q_mono = []
         else:
             raise ValueError("Unknown data type") # never gets here
@@ -125,5 +129,6 @@
         # Remember function inputs so we can delay loading the function and
         # so we can save/restore state
-        self._kernel_inputs = [v for v in q_vectors]
+        self._kernel_inputs = q_vectors
+        self._kernel_mono_inputs = q_mono
         self._kernel = None
         self.Iq, self.dIq, self.index = Iq, dIq, index
@@ -149,14 +154,16 @@
     def _calc_theory(self, pars, cutoff=0.0):
         if self._kernel is None:
-            self._kernel = make_kernel(self._model, self._kernel_inputs)  # pylint: disable=attribute-defined-outside-init
+            self._kernel = make_kernel(self._model, self._kernel_inputs)  # pylint: disable=attribute-dedata_type
+            self._kernel_mono = make_kernel(self._model, self._kernel_mono_inputs) if self._kernel_mono_inputs else None
 
         Iq_calc = call_kernel(self._kernel, pars, cutoff=cutoff)
+        Iq_mono = call_kernel(self._kernel_mono, pars, mono=True) if self._kernel_mono_inputs else None
         if self.data_type == 'sesans':
-            result = sesans.hankel(self._data.x, self._data.lam * 1e-9,
-                                   self._data.sample.thickness / 10,
-                                   self._kernel_inputs[0], Iq_calc)
+            result = sesans.transform(self._data,
+                                   self._kernel_inputs[0], Iq_calc, 
+                                   self._kernel_mono_inputs, Iq_mono)
         else:
             result = self.resolution.apply(Iq_calc)
-        return result
+        return result        
 
 
Index: sasmodels/models/adsorbed_layer.py
===================================================================
--- sasmodels/models/adsorbed_layer.py	(revision f10bc52ab6508ac7b449d2990c9f805461b8996c)
+++ sasmodels/models/adsorbed_layer.py	(revision c079f5048e0520234276a4b55ef0538f7b83852c)
@@ -6,5 +6,5 @@
 
 r"""
-This model describes the scattering from a layer of surfactant or polymer adsorbed on spherical particles under the conditions that (i) the particles (cores) are contrast-matched to the dispersion medium, (ii) *S(Q)* ~ 1 (ie, the particle volume fraction is dilute), (iii) the particle radius is >> layer thickness (ie, the interface is locally flat), and (iv) scattering from excess unadsorbed adsorbate in the bulk medium is absent or has been corrected for.
+This model describes the scattering from a layer of surfactant or polymer adsorbed on large, smooth, notionally spherical particles under the conditions that (i) the particles (cores) are contrast-matched to the dispersion medium, (ii) *S(Q)* ~ 1 (ie, the particle volume fraction is dilute), (iii) the particle radius is >> layer thickness (ie, the interface is locally flat), and (iv) scattering from excess unadsorbed adsorbate in the bulk medium is absent or has been corrected for.
 
 Unlike many other core-shell models, this model does not assume any form for the density distribution of the adsorbed species normal to the interface (cf, a core-shell model normally assumes the density distribution to be a homogeneous step-function). For comparison, if the thickness of a (traditional core-shell like) step function distribution is *t*, the second moment about the mean of the density distribution (ie, the distance of the centre-of-mass of the distribution from the interface), |sigma| =  sqrt((*t* :sup:`2` )/12).
@@ -34,5 +34,5 @@
 
 description =  """
-    Evaluates the scattering from particles
+    Evaluates the scattering from large particles
     with an adsorbed layer of surfactant or
     polymer, independent of the form of the
@@ -42,22 +42,26 @@
 
 #             ["name", "units", default, [lower, upper], "type", "description"],
-parameters =  [["second_moment", "Ang", 23.0, [0.0, inf], "", "Second moment"],
-              ["adsorbed_amount", "mg/m2", 1.9, [0.0, inf], "", "Adsorbed amount"],
-              ["density_poly", "g/cm3", 0.7, [0.0, inf], "", "Polymer density"],
-              ["radius", "Ang", 500.0, [0.0, inf], "", "Particle radius"],
-              ["volfraction", "None", 0.14, [0.0, inf], "", "Particle vol fraction"],
-              ["polymer_sld", "1/Ang^2", 1.5e-06, [-inf, inf], "", "Polymer SLD"],
-              ["solvent_sld", "1/Ang^2", 6.3e-06, [-inf, inf], "", "Solvent SLD"]]
+parameters =  [["second_moment", "Ang", 23.0, [0.0, inf], "", "Second moment of polymer distribution"],
+              ["adsorbed_amount", "mg/m2", 1.9, [0.0, inf], "", "Adsorbed amount of polymer"],
+              ["density_shell", "g/cm3", 0.7, [0.0, inf], "", "Bulk density of polymer in the shell"],
+              ["radius", "Ang", 500.0, [0.0, inf], "", "Core particle radius"],
+              ["volfraction", "None", 0.14, [0.0, inf], "", "Core particle volume fraction"],
+              ["sld_shell", "1e-6/Ang^2", 1.5, [-inf, inf], "sld", "Polymer shell SLD"],
+              ["sld_solvent", "1e-6/Ang^2", 6.3, [-inf, inf], "sld", "Solvent SLD"]]
 
 # NB: Scale and Background are implicit parameters on every model
-def Iq(q, second_moment, adsorbed_amount, density_poly, radius, 
-        volfraction, polymer_sld, solvent_sld):
+def Iq(q, second_moment, adsorbed_amount, density_shell, radius, 
+        volfraction, sld_shell, sld_solvent):
     # pylint: disable = missing-docstring
-    deltarhosqrd =  (polymer_sld - solvent_sld) * (polymer_sld - solvent_sld)
-    numerator =  6.0 * pi * volfraction * (adsorbed_amount * adsorbed_amount)
-    denominator =  (q * q) * (density_poly * density_poly) * radius
-    eterm =  exp(-1.0 * (q * q) * (second_moment * second_moment))
-    #scale by 10^10 for units conversion to cm^-1
-    inten =  1.0e+10 * deltarhosqrd * ((numerator / denominator) * eterm)
+#    deltarhosqrd =  (sld_shell - sld_solvent) * (sld_shell - sld_solvent)
+#    numerator =  6.0 * pi * volfraction * (adsorbed_amount * adsorbed_amount)
+#    denominator =  (q * q) * (density_shell * density_shell) * radius
+#    eterm =  exp(-1.0 * (q * q) * (second_moment * second_moment))
+#    #scale by 10^-2 for units conversion to cm^-1
+#    inten =  1.0e-02 * deltarhosqrd * ((numerator / denominator) * eterm)
+    aa =  (sld_shell - sld_solvent) * adsorbed_amount / q / density_shell 
+    bb = q * second_moment
+    #scale by 10^-2 for units conversion to cm^-1
+    inten =  6.0e-02 * pi * volfraction * aa * aa * exp(-bb * bb) / radius
     return inten
 Iq.vectorized =  True  # Iq accepts an array of q values
@@ -71,9 +75,9 @@
             second_moment = 23.0,
             adsorbed_amount = 1.9,
-            density_poly = 0.7,
+            density_shell = 0.7,
             radius = 500.0,
             volfraction = 0.14,
-            polymer_sld = 1.5e-06,
-            solvent_sld = 6.3e-06,
+            sld_shell = 1.5,
+            sld_solvent = 6.3,
             background = 0.0)
 
@@ -82,9 +86,9 @@
                second_moment = 'second_moment',
                adsorbed_amount = 'ads_amount',
-               density_poly = 'density_poly',
+               density_shell = 'density_poly',
                radius = 'radius_core',
                volfraction = 'volf_cores',
-               polymer_sld = 'sld_poly',
-               solvent_sld = 'sld_solv',
+               sld_shell = 'sld_poly',
+               sld_solvent = 'sld_solv',
                background = 'background')
 
@@ -92,6 +96,7 @@
 tests =  [
     [{'scale': 1.0, 'second_moment': 23.0, 'adsorbed_amount': 1.9, 
-     'density_poly': 0.7, 'radius': 500.0, 'volfraction': 0.14, 
-     'polymer_sld': 1.5e-06, 'solvent_sld': 6.3e-06, 'background': 0.0},
+     'density_shell': 0.7, 'radius': 500.0, 'volfraction': 0.14, 
+     'sld_shell': 1.5, 'sld_solvent': 6.3, 'background': 0.0},
      [0.0106939, 0.469418], [73.741, 9.65391e-53]],
     ]
+# ADDED by: SMK  ON: 16Mar2016  convert from sasview, check vs SANDRA, 18Mar2016 RKH some edits & renaming
Index: sasmodels/models/binary_hard_sphere.c
===================================================================
--- sasmodels/models/binary_hard_sphere.c	(revision 115d0f015d008c59c827203a96ee8894b7ec49b4)
+++ sasmodels/models/binary_hard_sphere.c	(revision 115d0f015d008c59c827203a96ee8894b7ec49b4)
@@ -0,0 +1,193 @@
+double form_volume(void);
+
+double Iq(double q, 
+    double lg_radius, double sm_radius,
+    double lg_vol_frac, double sm_vol_frac,
+    double lg_sld, double sm_sld, double solvent_sld
+    );
+    
+double Iqxy(double qx, double qy,
+    double lg_radius, double sm_radius,
+    double lg_vol_frac, double sm_vol_frac,
+    double lg_sld, double sm_sld, double solvent_sld
+    );
+
+int calculate_psfs(double qval,
+    double r2, double nf2,
+    double aa, double phi,
+    double *s11, double *s22, double *s12
+    );
+
+double form_volume(void)
+{
+    return 1.0;
+}
+
+double Iq(double q,
+    double lg_radius, double sm_radius,
+    double lg_vol_frac, double sm_vol_frac,
+    double lg_sld, double sm_sld, double solvent_sld)
+    
+{
+    double r2,r1,nf2,phi,aa,rho2,rho1,rhos,inten;       //my local names
+    double psf11,psf12,psf22;
+    double phi1,phi2,phr,a3;
+    double v1,v2,n1,n2,qr1,qr2,b1,b2,sc1,sc2;
+    int err;
+    
+    r2 = lg_radius;
+    r1 = sm_radius;
+    phi2 = lg_vol_frac;
+    phi1 = sm_vol_frac;
+    rho2 = lg_sld;
+    rho1 = sm_sld;
+    rhos = solvent_sld;
+    
+    
+    phi = phi1 + phi2;
+    aa = r1/r2;
+    //calculate the number fraction of larger spheres (eqn 2 in reference)
+    a3=aa*aa*aa;
+    phr=phi2/phi;
+    nf2 = phr*a3/(1.0-phr+phr*a3);
+    // calculate the PSF's here
+    err = calculate_psfs(q,r2,nf2,aa,phi,&psf11,&psf22,&psf12);
+    
+    // /* do form factor calculations  */
+    
+    v1 = 4.0*M_PI/3.0*r1*r1*r1;
+    v2 = 4.0*M_PI/3.0*r2*r2*r2;
+    
+    n1 = phi1/v1;
+    n2 = phi2/v2;
+    
+    qr1 = r1*q;
+    qr2 = r2*q;
+
+    //if (qr1 == 0){
+        //sc1 = 1.0/3.0;
+    //}else{
+        //sc1 = (sin(qr1)-qr1*cos(qr1))/qr1/qr1/qr1;
+    //}
+    //if (qr2 == 0){
+        //sc2 = 1.0/3.0;
+    //}else{
+        //sc2 = (sin(qr2)-qr2*cos(qr2))/qr2/qr2/qr2;
+    //}
+    sc1 = sph_j1c(qr1);
+    sc2 = sph_j1c(qr2);
+    b1 = r1*r1*r1*(rho1-rhos)*4.0/3.0*M_PI*sc1;
+    b2 = r2*r2*r2*(rho2-rhos)*4.0/3.0*M_PI*sc2;
+    inten = n1*b1*b1*psf11;
+    inten += sqrt(n1*n2)*2.0*b1*b2*psf12;
+    inten += n2*b2*b2*psf22;
+    ///* convert I(1/A) to (1/cm)  */
+    inten *= 1.0e8;
+    ///*convert rho^2 in 10^-6A to A*/
+    inten *= 1.0e-12;    
+    return(inten);
+}
+
+
+double Iqxy(double qx, double qy,
+    double lg_radius, double sm_radius,
+    double lg_vol_frac, double sm_vol_frac,
+    double lg_sld, double sm_sld, double solvent_sld)
+    
+{
+    double q = sqrt(qx*qx + qy*qy);
+    return Iq(q,
+        lg_radius, sm_radius,
+        lg_vol_frac, sm_vol_frac,
+        lg_sld, sm_sld, solvent_sld);
+}
+
+int calculate_psfs(double qval,
+    double r2, double nf2,
+    double aa, double phi,
+    double *s11, double *s22, double *s12)
+
+{
+    //  variable qval,r2,nf2,aa,phi,&s11,&s22,&s12
+    
+    //   calculate constant terms
+    double s1,s2,v,a3,v1,v2,g11,g12,g22,wmv,wmv3,wmv4;
+    double a1,a2i,a2,b1,b2,b12,gm1,gm12;
+    double err=0.0,yy,ay,ay2,ay3,t1,t2,t3,f11,y2,y3,tt1,tt2,tt3;
+    double c11,c22,c12,f12,f22,ttt1,ttt2,ttt3,ttt4,yl,y13;
+    double t21,t22,t23,t31,t32,t33,t41,t42,yl3,wma3,y1;
+    
+    s2 = 2.0*r2;
+    s1 = aa*s2;
+    v = phi;
+    a3 = aa*aa*aa;
+    v1=((1.-nf2)*a3/(nf2+(1.-nf2)*a3))*v;
+    v2=(nf2/(nf2+(1.-nf2)*a3))*v;
+    g11=((1.+.5*v)+1.5*v2*(aa-1.))/(1.-v)/(1.-v);
+    g22=((1.+.5*v)+1.5*v1*(1./aa-1.))/(1.-v)/(1.-v);
+    g12=((1.+.5*v)+1.5*(1.-aa)*(v1-v2)/(1.+aa))/(1.-v)/(1.-v);
+    wmv = 1/(1.-v);
+    wmv3 = wmv*wmv*wmv;
+    wmv4 = wmv*wmv3;
+    a1=3.*wmv4*((v1+a3*v2)*(1.+v+v*v)-3.*v1*v2*(1.-aa)*(1.-aa)*(1.+v1+aa*(1.+v2))) + ((v1+a3*v2)*(1.+2.*v)+(1.+v+v*v)-3.*v1*v2*(1.-aa)*(1.-aa)-3.*v2*(1.-aa)*(1.-aa)*(1.+v1+aa*(1.+v2)))*wmv3;
+    a2i=((v1+a3*v2)*(1.+v+v*v)-3.*v1*v2*(1.-aa)*(1.-aa)*(1.+v1+aa*(1.+v2)))*3*wmv4 + ((v1+a3*v2)*(1.+2.*v)+a3*(1.+v+v*v)-3.*v1*v2*(1.-aa)*(1.-aa)*aa-3.*v1*(1.-aa)*(1.-aa)*(1.+v1+aa*(1.+v2)))*wmv3;
+    a2=a2i/a3;
+    b1=-6.*(v1*g11*g11+.25*v2*(1.+aa)*(1.+aa)*aa*g12*g12);
+    b2=-6.*(v2*g22*g22+.25*v1/a3*(1.+aa)*(1.+aa)*g12*g12);
+    b12=-3.*aa*(1.+aa)*(v1*g11/aa/aa+v2*g22)*g12;
+    gm1=(v1*a1+a3*v2*a2)*.5;
+    gm12=2.*gm1*(1.-aa)/aa;
+    //c  
+    //c   calculate the direct correlation functions and print results
+    //c
+    //  do 20 j=1,npts
+    
+    yy=qval*s2;
+    //c   calculate direct correlation functions
+    //c   ----c11
+    ay=aa*yy;
+    ay2 = ay*ay;
+    ay3 = ay*ay*ay;
+    t1=a1*(sin(ay)-ay*cos(ay));
+    t2=b1*(2.*ay*sin(ay)-(ay2-2.)*cos(ay)-2.)/ay;
+    t3=gm1*((4.*ay*ay2-24.*ay)*sin(ay)-(ay2*ay2-12.*ay2+24.)*cos(ay)+24.)/ay3;
+    f11=24.*v1*(t1+t2+t3)/ay3;
+    
+    //c ------c22
+    y2=yy*yy;
+    y3=yy*y2;
+    tt1=a2*(sin(yy)-yy*cos(yy));
+    tt2=b2*(2.*yy*sin(yy)-(y2-2.)*cos(yy)-2.)/yy;
+    tt3=gm1*((4.*y3-24.*yy)*sin(yy)-(y2*y2-12.*y2+24.)*cos(yy)+24.)/ay3;
+    f22=24.*v2*(tt1+tt2+tt3)/y3;
+    
+    //c   -----c12
+    yl=.5*yy*(1.-aa);
+    yl3=yl*yl*yl;
+    wma3 = (1.-aa)*(1.-aa)*(1.-aa);
+    y1=aa*yy;
+    y13 = y1*y1*y1;
+    ttt1=3.*wma3*v*sqrt(nf2)*sqrt(1.-nf2)*a1*(sin(yl)-yl*cos(yl))/((nf2+(1.-nf2)*a3)*yl3);
+    t21=b12*(2.*y1*cos(y1)+(y1*y1-2.)*sin(y1));
+    t22=gm12*((3.*y1*y1-6.)*cos(y1)+(y1*y1*y1-6.*y1)*sin(y1)+6.)/y1;
+    t23=gm1*((4.*y13-24.*y1)*cos(y1)+(y13*y1-12.*y1*y1+24.)*sin(y1))/(y1*y1);
+    t31=b12*(2.*y1*sin(y1)-(y1*y1-2.)*cos(y1)-2.);
+    t32=gm12*((3.*y1*y1-6.)*sin(y1)-(y1*y1*y1-6.*y1)*cos(y1))/y1;
+    t33=gm1*((4.*y13-24.*y1)*sin(y1)-(y13*y1-12.*y1*y1+24.)*cos(y1)+24.)/(y1*y1);
+    t41=cos(yl)*((sin(y1)-y1*cos(y1))/(y1*y1) + (1.-aa)/(2.*aa)*(1.-cos(y1))/y1);
+    t42=sin(yl)*((cos(y1)+y1*sin(y1)-1.)/(y1*y1) + (1.-aa)/(2.*aa)*sin(y1)/y1);
+    ttt2=sin(yl)*(t21+t22+t23)/(y13*y1);
+    ttt3=cos(yl)*(t31+t32+t33)/(y13*y1);
+    ttt4=a1*(t41+t42)/y1;
+    f12=ttt1+24.*v*sqrt(nf2)*sqrt(1.-nf2)*a3*(ttt2+ttt3+ttt4)/(nf2+(1.-nf2)*a3);
+    
+    c11=f11;
+    c22=f22;
+    c12=f12;
+    *s11=1./(1.+c11-(c12)*c12/(1.+c22));
+    *s22=1./(1.+c22-(c12)*c12/(1.+c11)); 
+    *s12=-c12/((1.+c11)*(1.+c22)-(c12)*(c12));   
+    
+    return(err);
+}
+
Index: sasmodels/models/binary_hard_sphere.py
===================================================================
--- sasmodels/models/binary_hard_sphere.py	(revision 115d0f015d008c59c827203a96ee8894b7ec49b4)
+++ sasmodels/models/binary_hard_sphere.py	(revision 115d0f015d008c59c827203a96ee8894b7ec49b4)
@@ -0,0 +1,128 @@
+r"""
+
+The binary hard sphere model provides the scattering intensity, for binary
+mixture of hard spheres including hard sphere interaction between those
+particles, using rhw Percus-Yevick closure. The calculation is an exact
+multi-component solution that properly accounts for the 3 partial structure
+factors.
+
+Definition
+----------
+
+.. math::
+
+    \begin{eqnarray}
+    I(q) = (1-x)f_1^2(q) S_{11}(q) + 2[x(1-x)]^{1/2} f_1(q)f_2(q)S_{12}(q) + \\
+    x\,f_2^2(q)S_{22}(q) \\
+    \end{eqnarray}
+
+where $S_{ij}$ are the partial structure factors and $f_i$ are the scattering
+amplitudes of the particles. The subscript 1 is for the smaller particle and 2
+is for the larger. The number fraction of the larger particle,
+($x = n2/(n1+n2)$, where $n$ = the number density) is internally calculated
+based on the diameter ratio and the volume fractions.
+
+.. math::
+
+    \begin{eqnarray}
+    x &=& \frac{(\phi_2 / \phi)\alpha^3}{(1-(\phi_2/\phi) + (\phi_2/\phi) \\
+    \alpha^3)} \phi &=& \phi_1 + \phi_2 = \text{total volume fraction} \\
+    \alpha &=& R_1/R_2 = \text{size ratio}
+    \end{eqnarray}
+
+The 2D scattering intensity is the same as 1D, regardless of the orientation of
+the *q* vector which is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+**NOTE 1:** The volume fractions and the scattering contrasts are loosely
+correlated, so holding as many parameters fixed to known values during fitting
+will improve the robustness of the fit.
+
+**NOTE 2:** Since the calculation uses the Percus-Yevick closure, all of the
+limitations of that closure relation apply here. Specifically, one should be
+wary of results for (total) volume fractions greater than approximately 40%.
+Depending on the size ratios or number fractions, the limit on total volume
+fraction may be lower.
+
+**NOTE 3:** The heavy arithmatic operations also mean that at present the
+function is poorly behaved at very low qr.  In some cases very large qr may
+also be poorly behaved.  These should however be outside any useful region of
+qr.
+
+The code for this model is based originally on a c-library implementation by the
+NIST Center for Neutron Research (Kline, 2006).
+
+See the references for details.
+
+References
+----------
+
+N W Ashcroft and D C Langreth, *Physical Review*, 156 (1967) 685-692
+[Errata found in *Phys. Rev.* 166 (1968) 934]
+
+S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+
+**Author:** N/A **on:**
+
+**Modified by:** Paul Butler **on:** March 18, 2016
+
+**Reviewed by:** Paul Butler **on:** March 18, 2016
+"""
+
+import numpy as np
+from numpy import pi, inf
+
+name = "binary_hard_sphere"
+title = "binary mixture of hard spheres with hard sphere interactions."
+description = """Describes the scattering from a mixture of two distinct
+monodisperse, hard sphere particles.
+        [Parameters];
+        radius_lg: large radius of binary hard sphere,
+        radius_sm: small radius of binary hard sphere,
+        volfraction_lg: volume fraction of large spheres,
+        volfraction_sm: volume fraction of small spheres,
+        sld_lg: large sphere  scattering length density,
+        sld_sm: small sphere scattering length density,
+        sld_solvent: solvent scattering length density.
+"""
+category = "shape:sphere"
+
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["radius_lg", "Ang", 100, [0, inf], "",
+               "radius of large particle"],
+              ["radius_sm", "Ang", 25, [0, inf], "",
+               "radius of small particle"],
+              ["volfraction_lg", "", 0.1, [0, 1], "",
+               "volume fraction of large particle"],
+              ["volfraction_sm", "", 0.2, [0, 1], "",
+               "volume fraction of small particle"],
+              ["sld_lg", "1e-6/Ang^2", 3.5, [-inf, inf], "",
+               "scattering length density of large particle"],
+              ["sld_sm", "1e-6/Ang^2", 0.5, [-inf, inf], "",
+               "scattering length density of small particle"],
+              ["sld_solvent", "1e-6/Ang^2", 6.36, [-inf, inf], "",
+               "Solvent scattering length density"],
+             ]
+
+source = ["lib/sph_j1c.c", "binary_hard_sphere.c"]
+
+# parameters for demo and documentation
+demo = dict(scale=1, background=0,
+            sld_lg=3.5, sld_sm=0.5, sld_solvent=6.36,
+            radius_lg=100, radius_sm=20,
+            volfraction_lg=0.1, volfraction_sm=0.2)
+
+# For testing against the old sasview models, include the converted parameter
+# names and the target sasview model name.
+oldname = 'BinaryHSModel'
+oldpars = dict(volfraction_lg='vol_frac_ls', volfraction_sm='vol_frac_ss',
+               sld_lg='ls_sld', sld_sm='ss_sld', sld_solvent='solvent_sld',
+               radius_lg='l_radius', radius_sm='s_radius')
+
+# NOTE: test results taken from values returned by SasView 3.1.2
+tests = [[{'scale':1.0}, 0.001, 25.8927262013]]
+
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision e7678b2f993854334aca4c45e1c7022b2fdbb509)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -8,7 +8,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld);
+          double sld_core,
+          double sld_shell,
+          double sld_solvent);
 
 
@@ -18,7 +18,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi);
@@ -40,7 +40,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld)
+          double sld_core,
+          double sld_shell,
+          double sld_solvent)
 {
 
@@ -51,6 +51,6 @@
     double summ = 0.0;	 //initialize intergral
 
-    const double delpc = core_sld - shell_sld;    //core - shell
-    const double delps = shell_sld - solvent_sld; //shell - solvent
+    const double delpc = sld_core - sld_shell;    //core - shell
+    const double delps = sld_shell - sld_solvent; //shell - solvent
 
     for(int i=0;i<N_POINTS_76;i++) {
@@ -81,7 +81,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi)
@@ -96,6 +96,6 @@
     const double cyl_y = sin(theta);
 
-    const double sldcs = core_sld - shell_sld;
-    const double sldss = shell_sld- solvent_sld;
+    const double sldcs = sld_core - sld_shell;
+    const double sldss = sld_shell- sld_solvent;
 
     // Compute the angle btw vector q and the
@@ -124,7 +124,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld)
+          double sld_core,
+          double sld_shell,
+          double sld_solvent)
 {
     double intensity = core_shell_ellipsoid_kernel(q,
@@ -133,7 +133,7 @@
            equat_shell,
            polar_shell,
-           core_sld,
-           shell_sld,
-           solvent_sld);
+           sld_core,
+           sld_shell,
+           sld_solvent);
 
     return intensity;
@@ -146,7 +146,7 @@
           double equat_shell,
           double polar_shell,
-          double core_sld,
-          double shell_sld,
-          double solvent_sld,
+          double sld_core,
+          double sld_shell,
+          double sld_solvent,
           double theta,
           double phi)
@@ -159,7 +159,7 @@
                        equat_shell,
                        polar_shell,
-                       core_sld,
-                       shell_sld,
-                       solvent_sld,
+                       sld_core,
+                       sld_shell,
+                       sld_solvent,
                        theta,
                        phi);
